* This do-file gets the trade data ready for analysis of agricultural trade flows

global date = "091511"
global dropbox = "C:\Users\Treb\Documents\My Dropbox"
global dir = "$dropbox\Research\Data\Philippines\Agricultural Trade"
global dir_trade = "$dropbox\Research\Data\Philippines\DOMSTAT"
global dir_prices = "$dropbox\Research\Trade\Information\Empirics\Rainfall Predicted Prices"
global dir_prices_w = "$dropbox\Research\Data\Philippines\Provincial Data\Wholesale Prices"
global dir_production = "$dropbox\Research\Data\Philippines\Provincial Data\Crop Production"
global dir_province = "$dropbox\Research\Data\Philippines\"
global dir_distance = "$dropbox\Research\Data\Philippines\Geographic Data\Shipping Distances"
global dir_land = "$dropbox\Research\Data\Philippines\Census of Agriculture\1991"
global dir_island = "$dropbox\Research\Data\Philippines\Geographic Data\Road Distances"

cd "$dir"
clear

*** Preparing the islands
	clear
	use "$dir_island\islands_040411.dta"
	keep province_id island_group
	ren island_group island_id
	sort province_id
	tempfile temp_island
	save `temp_island', replace
	

*** Preparing the land distribution
	clear
	use "$dir_land\theta_080411.dta"
	
	* converting into product specific land distribution
	sort province_id
	by province_id: assert _n==1
	expand 21
	bysort province_id: gen temp = _n
	gen agprod_name=""
	
		* agprod_name
		replace agprod_name="Abaca" if temp==1
		replace agprod_name="Banana" if temp==2
		replace agprod_name="Cabbage" if temp==3
		replace agprod_name="Calamansi" if temp==4
		replace agprod_name="Carrot" if temp==5
		replace agprod_name="Cassava" if temp==6
		replace agprod_name="Coconut" if temp==7
		replace agprod_name="Coffee" if temp==8
		replace agprod_name="Corn" if temp==9
		replace agprod_name="Garlic" if temp==10
		replace agprod_name="Ginger" if temp==11
		replace agprod_name="Mango" if temp==12
		replace agprod_name="Mongo" if temp==13
		replace agprod_name="Onion" if temp==14
		replace agprod_name="Peanut" if temp==15
		replace agprod_name="Pineapple" if temp==16
		replace agprod_name="Potato" if temp==17
		replace agprod_name="Rice" if temp==18
		replace agprod_name="Sweet Potato" if temp==19
		replace agprod_name="Tobacco" if temp==20
		replace agprod_name="Tomato" if temp==21
		
		* theta
		gen theta=.
		gen theta_se=.
		gen fsub=.
		foreach var in theta fsub {
			replace `var' = `var'_abac if agprod_name=="Abaca"
			replace `var' = `var'_bana if agprod_name=="Banana"
			replace `var' = `var'_cabb if agprod_name=="Cabbage"
			replace `var' = `var'_cala if agprod_name=="Calamansi"
			replace `var' = `var'_carr if agprod_name=="Carrot"
			replace `var' = `var'_cass if agprod_name=="Cassava"
			replace `var' = `var'_coco if agprod_name=="Coconut"
			replace `var' = `var'_coff if agprod_name=="Coffee"
			replace `var' = `var'_corn if agprod_name=="Corn"
			replace `var' = `var'_garl if agprod_name=="Garlic"
			replace `var' = `var'_ging if agprod_name=="Ginger"
			replace `var' = `var'_mang if agprod_name=="Mango"
			replace `var' = `var'_bean if agprod_name=="Mongo"
			replace `var' = `var'_onio if agprod_name=="Onion"
			replace `var' = `var'_pean if agprod_name=="Peanut"
			replace `var' = `var'_pine if agprod_name=="Pineapple"
			replace `var' = `var'_pota if agprod_name=="Potato"
			replace `var' = `var'_palay if agprod_name=="Rice"
			replace `var' = `var'_swee if agprod_name=="Sweet Potato"
			replace `var' = `var'_toba if agprod_name=="Tobacco"
			replace `var' = `var'_toma if agprod_name=="Tomato"
		}

			replace theta_se = theta_abac_se if agprod_name=="Abaca"
			replace theta_se = theta_bana_se if agprod_name=="Banana"
			replace theta_se = theta_cabb_se if agprod_name=="Cabbage"
			replace theta_se = theta_cala_se if agprod_name=="Calamansi"
			replace theta_se = theta_carr_se if agprod_name=="Carrot"
			replace theta_se = theta_cass_se if agprod_name=="Cassava"
			replace theta_se = theta_coco_se if agprod_name=="Coconut"
			replace theta_se = theta_coff_se if agprod_name=="Coffee"
			replace theta_se = theta_corn_se if agprod_name=="Corn"
			replace theta_se = theta_garl_se if agprod_name=="Garlic"
			replace theta_se = theta_ging_se if agprod_name=="Ginger"
			replace theta_se = theta_mang_se if agprod_name=="Mango"
			replace theta_se = theta_bean_se if agprod_name=="Mongo"
			replace theta_se = theta_onio_se if agprod_name=="Onion"
			replace theta_se = theta_pean_se if agprod_name=="Peanut"
			replace theta_se = theta_pine_se if agprod_name=="Pineapple"
			replace theta_se = theta_pota_se if agprod_name=="Potato"
			replace theta_se = theta_palay_se if agprod_name=="Rice"
			replace theta_se = theta_swee_se if agprod_name=="Sweet Potato"
			replace theta_se = theta_toba_se if agprod_name=="Tobacco"
			replace theta_se = theta_toma_se if agprod_name=="Tomato"
	
	replace theta_se = . if theta<1
	replace theta=. if theta<1 /* otherwise no finite mean */
	cap drop temp*
	bysort agprod_name: egen temp = mean(theta)
	replace theta = temp if theta==. /* take the average theta for those provinces not reporting a theta */
	drop temp
	bysort agprod_name: egen temp = mean(fsub)
	replace fsub = temp if fsub==. /* take the average fsub for those provinces not reporting a fsub */
	drop temp
	
	keep province_id agprod_name theta theta_se fsub
	sort province_id agprod_name
	by province_id agprod_name: assert _n==1
	
	lab var theta "Province-product land distribution parameter"
	lab var theta_se "SE of theta"
	lab var fsub "Province-product fraction of subsistence farmers"
	
	tempfile temp_land
	save `temp_land', replace

*** Step #1: Pairing down to agricultural products only
	use "$dir_trade\trade_cleaned.dta"

	* Agricultural product names by SITC code
	gen agprod_name = ""
	replace agprod_name="Abaca" if substr(prod_id,1,4)=="2655"
	replace agprod_name="Apples" if substr(prod_id,1,5)=="05740"
	replace agprod_name="Bamboo" if substr(prod_id,1,5)=="29231"
	replace agprod_name="Banana" if substr(prod_id,1,5)=="05730"
	replace agprod_name="Mongo" if substr(prod_id,1,5)=="05423"
	replace agprod_name="Beet sugar" if substr(prod_id,1,5)=="06112"
	replace agprod_name="Buckwheat" if substr(prod_id,1,5)=="04592"
	replace agprod_name="Cabbage" if substr(prod_id,1,5)=="05453"
	replace agprod_name="Calamansi" if substr(prod_id,1,5)=="05729"
	replace agprod_name="Canary seed" if substr(prod_id,1,5)=="04593"
	replace agprod_name="Carrot" if substr(prod_id,1,5)=="05455"
	replace agprod_name="Cashews" if substr(prod_id,1,5)=="05773"
	replace agprod_name="Cassava" if substr(prod_id,1,5)=="05481"
	replace agprod_name="Castor oil seeds" if substr(prod_id,1,4)=="2235"
	replace agprod_name="Chicken" if substr(prod_id,1,4)=="0014"
	replace agprod_name="Chick-peas" if substr(prod_id,1,5)=="05422"
	replace agprod_name="Cocoa" if substr(prod_id,1,3)=="072"
	replace agprod_name="Coconut" if substr(prod_id,1,5)=="05771"
	replace agprod_name="Coffee" if substr(prod_id,1,3)=="071"
	replace agprod_name="Copra" if substr(prod_id,1,5)=="08137"
	replace agprod_name="Copra" if substr(prod_id,1,4)=="2231"
	replace agprod_name="Corn" if substr(prod_id,1,5)=="04721"
	replace agprod_name="Corn" if substr(prod_id,1,5)=="08124"
	replace agprod_name="Corn" if substr(prod_id,1,3)=="044"
	replace agprod_name="Cotton" if substr(prod_id,1,3)=="263"
	replace agprod_name="Cattle" if substr(prod_id,1,4)=="0011"
	replace agprod_name="Cucumbers" if substr(prod_id,1,5)=="05456"
	replace agprod_name="Eggs" if substr(prod_id,1,4)=="0251"
	replace agprod_name="Flowers" if substr(prod_id,1,5)=="29271"
	replace agprod_name="Garlic" if substr(prod_id,1,5)=="05452"
	replace agprod_name="Ginger" if substr(prod_id,1,5)=="07527"
	replace agprod_name="Goats" if substr(prod_id,1,5)=="00122"
	replace agprod_name="Grapes" if substr(prod_id,1,5)=="05751"
	replace agprod_name="Jute" if substr(prod_id,1,4)=="2641"
	replace agprod_name="Lettuce" if substr(prod_id,1,5)=="05454"
	replace agprod_name="Mandarins" if substr(prod_id,1,5)=="05712"
	replace agprod_name="Mango" if substr(prod_id,1,5)=="05797"
	replace agprod_name="Melons" if substr(prod_id,1,5)=="05791"
	replace agprod_name="Millet" if substr(prod_id,1,5)=="04591"
	replace agprod_name="Mushrooms" if substr(prod_id,1,5)=="05458"
	replace agprod_name="Oats" if substr(prod_id,1,4)=="0452"
	replace agprod_name="Onion" if substr(prod_id,1,5)=="05451"
	replace agprod_name="Oranges" if substr(prod_id,1,5)=="05711"
	replace agprod_name="Palm nuts" if substr(prod_id,1,4)=="2232"
	replace agprod_name="Peanut" if substr(prod_id,1,4)=="2221"
	replace agprod_name="Peas" if substr(prod_id,1,5)=="05421"
	replace agprod_name="Pepper" if substr(prod_id,1,4)=="0751"
	replace agprod_name="Pigs" if substr(prod_id,1,4)=="0013"
	replace agprod_name="Pineapple" if substr(prod_id,1,5)=="05795"
	replace agprod_name="Potato" if substr(prod_id,1,4)=="0541"
	replace agprod_name="Raisins" if substr(prod_id,1,5)=="05752"
	replace agprod_name="Rattan" if substr(prod_id,1,5)=="29232"
	replace agprod_name="Rice" if substr(prod_id,1,5)=="08125"
	replace agprod_name="Rice" if substr(prod_id,1,3)=="042"
	replace agprod_name="Sorghum" if substr(prod_id,1,4)=="0453"
	replace agprod_name="Soy" if substr(prod_id,1,5)=="08131"
	replace agprod_name="Soy" if substr(prod_id,1,4)=="2222"
	replace agprod_name="Sugar" if substr(prod_id,1,5)=="06151"
	replace agprod_name="Sugar" if substr(prod_id,1,5)=="06111"
	replace agprod_name="Sugar" if substr(prod_id,1,5)=="05488"
	replace agprod_name="Sweet Potato" if substr(prod_id,1,5)=="05483"
	replace agprod_name="Tobacco" if substr(prod_id,1,3)=="121"
	replace agprod_name="Tomato" if substr(prod_id,1,4)=="0544"
	replace agprod_name="Vanilla" if substr(prod_id,1,5)=="07521"
	replace agprod_name="Wheat" if substr(prod_id,1,3)=="041"
	replace agprod_name="Wheat" if substr(prod_id,1,4)=="0461"

	* keeping only important agricultural products
	cap drop temp*
	gen temp = 0
	replace temp=1 if agprod_name=="Abaca"
	replace temp=1 if agprod_name=="Banana"
	replace temp=1 if agprod_name=="Cabbage"
	replace temp=1 if agprod_name=="Calamansi"
	replace temp=1 if agprod_name=="Cassava"
	replace temp=1 if agprod_name=="Coconut"
	replace temp=1 if agprod_name=="Coffee"
	replace temp=1 if agprod_name=="Corn"
	replace temp=1 if agprod_name=="Eggplant"
	replace temp=1 if agprod_name=="Garlic"
	replace temp=1 if agprod_name=="Mango"
	replace temp=1 if agprod_name=="Mongo"
	replace temp=1 if agprod_name=="Onion"
	replace temp=1 if agprod_name=="Peanut"
	replace temp=1 if agprod_name=="Pineapple"
	replace temp=1 if agprod_name=="Rice"
	replace temp=1 if agprod_name=="Rubber"
	replace temp=1 if agprod_name=="Sweet Potato"
	replace temp=1 if agprod_name=="Tobacco"
	replace temp=1 if agprod_name=="Tomato"
	
		* these products do not have production data
		replace temp=1 if agprod_name=="Ginger"
		replace temp=1 if agprod_name=="Carrot"
		replace temp=1 if agprod_name=="Potato"
		
	keep if temp==1
	drop temp
	keep if agprod_name~=""
	egen agprod_id = group(agprod_name)
	preserve
	bysort agprod_id: keep if _n==1
	keep agprod_name agprod_id
	sort agprod_id
	save "agprod_codes.dta", replace
	restore
	
	* converting freight to tao
	gen tao = freight / value + 1
	gen tao_4 = freight_4 / value_4 + 1
	replace tao = . if freight==0 /* this means that freight wasn't recorded */
	replace tao_4 = . if freight_4==0
	replace tao = 2 if tao>2 & tao<. /* less than 1% of obs */
	replace tao_4 = 2 if tao_4>2 & tao_4<.
	
** Step #2: Including observed farm gate prices and provincial production
	preserve
	
	clear
	use "$dir_province\province_id_MASTER.dta"
	sort province_id_trade
	save "$dir_province\province_id_MASTER.dta", replace
	restore

	preserve

	* wholesale prices
		clear
		use "$dir_prices\price_iv_070111"
		tempfile temp_price
		
		* creating a correpsondence between trade products and farmgate products
		ren crop agprod_name
		
		* putting prices in 2000 PHP
				foreach var of var price* {
					replace `var' = `var'/(0.768) if year==1995
					replace `var' = `var'/(0.843) if year==1996
					replace `var' = `var'/(0.871) if year==1997
					replace `var' = `var'/(0.943) if year==1998
					replace `var' = `var'/(0.985) if year==1999
					replace `var' = `var'/(1) if year==2000
					replace `var' = `var'/(1.047) if year==2001
					replace `var' = `var'/(1.069) if year==2002
					replace `var' = `var'/(1.093) if year==2003
					replace `var' = `var'/(1.116) if year==2004
					replace `var' = `var'/(1.239) if year==2005
					replace `var' = `var'/(1.307) if year==2006
					replace `var' = `var'/(1.350) if year==2007
					replace `var' = `var'/(1.533) if year==2008
					replace `var' = `var'/(1.6423) if year==2009
				}
		
		* preparing for merge with trade data
		sort year province_id agprod_name
		keep year province_id agprod_name price*
		save `temp_price', replace
		clear
	
	* Total production
		tempfile temp_production
		use "$dir_production\allcrops_annual_cleaned.dta"
		
		* creating the correspondence between products
		ren crop agprod_name
		replace agprod_name = "Rice" if agprod_name=="Palay"
		replace agprod_name = "Sweet Potato" if agprod_name=="Camote"
		
		* merging on the correct province_id's
		drop province_name
		ren province_id province_id_trade
		sort province_id_trade
		
		merge province_id_trade using "$dir_province\province_id_MASTER.dta"
		tab _merge
		keep if _merge==3
		drop _merge
		
		* preparing for merge with trade data
		sort year province_id agprod_name
		keep year province_id agprod_name volume
		save `temp_production', replace
		clear
		
	* Foreign imports / exports
		tempfile temp_imports
		use "$dir\agimports_070511.dta"
		ren quantity imports
		lab var imports "Quantity imported (kg.)"
		keep year province_id agprod_name imports
		sort year province_id agprod_name
		save `temp_imports', replace
		clear
		
		
		tempfile temp_exports
		use "$dir\agexports_070511.dta"
		ren quantity exports
		lab var exports "Quantity exported (kg.)"
		keep year province_id agprod_name exports
		sort year province_id agprod_name
		save `temp_exports', replace
		clear
		
	* merging
	restore
	
	
		* land (origin)
		ren province_orig_id province_id
		sort province_id agprod_name
		merge province_id agprod_name using `temp_land'
		tab _merge
		keep if _merge==3
		drop _merge
		
		* islands
		sort province_id
		merge province_id using `temp_island'
		tab _merge
		drop if _merge==2
		drop _merge
	
		* origin 
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_price'
		tab _merge
		drop if _merge==2
		drop _merge

		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_production'
		tab _merge
		drop if _merge==2
		drop _merge
		
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_imports'
		tab _merge
		drop if _merge==2
		drop _merge
		
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_exports'
		tab _merge
		drop if _merge==2
		drop _merge		
			
		ren province_id province_orig_id
		ren price price_orig
		ren price_predict price_predict_orig
		ren price_predict_se price_predict_se_orig
		ren price_island price_island_orig
		ren price_market price_market_orig
		ren price_predict_island price_predict_island_orig
		ren price_predict_market price_predict_market_orig
		ren volume production_orig
		ren imports imports_orig
		ren exports exports_orig
		ren theta theta_orig
		ren theta_se theta_se_orig
		ren fsub fsub_orig
		ren island_id island_orig_id
		
		* land (destination)
		ren province_dest_id province_id
		sort province_id agprod_name
		merge province_id agprod_name using `temp_land'
		tab _merge
		drop if _merge==2
		drop _merge
		
		* island
		sort province_id
		merge province_id using `temp_island'
		tab _merge
		drop if _merge==2
		drop _merge
		
		* destination 
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_price'
		tab _merge
		drop if _merge==2
		drop _merge

		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_production'
		tab _merge
		drop if _merge==2
		drop _merge

		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_imports'
		tab _merge
		drop if _merge==2
		drop _merge
		
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_exports'
		tab _merge
		drop if _merge==2
		drop _merge		
		
		ren province_id province_dest_id
		ren price price_dest
		ren price_predict price_predict_dest
		ren price_predict_se price_predict_se_dest
		ren price_island price_island_dest
		ren price_market price_market_dest
		ren price_predict_island price_predict_island_dest
		ren price_predict_market price_predict_market_dest
		ren volume production_dest
		ren imports imports_dest
		ren exports exports_dest
		ren fsub fsub_dest
		ren theta theta_dest
		ren theta_se theta_se_dest
		ren island_id island_dest_id
		replace production_orig = production_orig * 1000 /* unit conversion */
		replace production_dest = production_dest * 1000 /* unit conversion */	
			

** Step #3: Saving
	drop prod_id
	
	* saving port level data
	lab var theta_orig "Origin land distribution parameter"
	lab var fsub_orig "Origin fraction of subsistence farmers"
	lab var theta_dest "Destination land distribution parameter"
	lab var fsub_dest "Destination fraction of subsistence farmers"
	lab var quantity "Quantity (kg.)"
	lab var value "Value (pesos)"
	lab var quantity_4 "Quantity - 4th Quarter (kg.)"
	lab var value_4 "Value - 4th Quarter (pesos)"
	lab var tao "Iceberg Freight Cost"
	lab var tao_4 "Iceberg Freight Cost - 4th Quarter"
	lab var distance "Shipping Distance (pixels)"
	lab var province_orig_id "Province Origin ID"
	lab var province_dest_id "Province Destination ID"
	lab var price_orig "Origin wholesale price"
	lab var price_dest "Destination wholesale price"
	lab var price_predict_orig "Origin predicted wholesale price"
	lab var price_predict_dest "Destination predicted wholesale price"
	lab var price_predict_se_orig "Origin SE of predicted wholesale price"
	lab var price_predict_se_dest "Destination SE of predicted wholesale price"
	lab var production_orig "Total production in origin province"
	lab var production_dest "Total production in destination province"
	lab dat "Agricultural trade flow data, port-port"
	save agtrade_port.dta, replace

	* aggregating up to commodity-year-province destination-province origin
	drop freight freight_4
	collapse (sum) quantity value quantity_4 value_4 (mean) tao tao_4 distance province_orig_id province_dest_id price_* theta* fsub* island_orig_id island_dest_id ///
		production_orig production_dest agprod_id exports_orig exports_dest imports_orig imports_dest, by(year agprod_name province_orig_name province_dest_name)
	lab var quantity "Quantity (kg.)"
	lab var value "Value (pesos)"
	lab var quantity_4 "Quantity - 4th Quarter (kg.)"
	lab var value_4 "Value - 4th Quarter (pesos)"
	lab var tao "Iceberg Freight Cost"
	lab var tao_4 "Iceberg Freight Cost - 4th Quarter"
	lab var distance "Shipping Distance (pixels)"
	lab var province_orig_id "Province Origin ID"
	lab var province_dest_id "Province Destination ID"
	lab var price_orig "Origin wholesale price"
	lab var price_dest "Destination wholesale price"
	lab var price_predict_orig "Origin predicted wholesale price"
	lab var price_predict_dest "Destination predicted wholesale price"
	lab var price_predict_se_orig "Origin SE of predicted wholesale price"
	lab var price_predict_se_dest "Destination SE of predicted wholesale price"
	lab var production_orig "Total production in origin province"
	lab var production_dest "Total production in destination province"
	lab var theta_orig "Origin land distribution parameter"
	lab var fsub_orig "Origin fraction of subsistence farmers"
	lab var theta_dest "Destination land distribution parameter"
	lab var fsub_dest "Destination fraction of subsistence farmers"
	
	* saving province level data
	lab dat "Agricultural trade flow data, province-province"
	save agtrade_prov.dta, replace
	
** Step #4: Including Zero Trade
* The extensive margin
clear

	* Extending the dataset to include zeros (so will always have 1 observation per origin province / destination province / product / year)
	* note: 84 provinces, 57 products, 15 years
	
	* The easiest way to make this data set is as follows:
	
		* Step 1: make a bunch of temporary files
		tempfile temp1
		clear
		set obs 84
		gen province_orig_id = _n
		save `temp1', replace
		
		tempfile temp2
		clear
		set obs 84
		gen province_dest_id = _n
		save `temp2', replace
		
		tempfile temp3
		clear
		set obs 21
		gen agprod_id = _n
		save `temp3', replace
		
		clear
		set obs 15
		gen year = 1994+_n
		
		* Step 2: Cross all the files
		tempfile temp4
		cross using `temp1'
		cross using `temp2'
		cross using `temp3'
		save `temp4', replace
	
		* Step 3: Append the empty observations to the actual observations
		clear
		use agtrade_prov.dta, replace
		keep year province_orig_id province_dest_id agprod_id agprod_name quantity value tao
		append using `temp4'
		
		* Step 4: Missing values equal 0
		foreach var of var quantity value tao {
			replace `var'=0 if `var'==.
			}
		
		* Step 4.5: making sure all have iceberg values
		sort province_orig_id province_dest_id agprod_id year tao
		by province_orig_id province_dest_id agprod_id year: replace tao=tao[_N]
		
		* Step 4.6: making sure all have agprod_names
		sort agprod_id
		drop agprod_name
		merge agprod_id using agprod_codes.dta
		tab _merge
		drop _merge
		
		* Step 5: Collapsing the dataset down to one observation per year / origin / destination / product
		collapse (max) quantity value tao, by(year province_orig_id province_dest_id agprod_name)
		
		* Step 6: Getting rid of provinces that never shipped
		gen temp = quantity>0
		bysort province_orig_id: egen evershipped = max(temp)
		keep if evershipped==1
		drop temp evershipped
		
		* Step 7: Getting rid of provinces that never received
		gen temp = quantity>0
		bysort province_dest_id: egen evershipped = max(temp)
		keep if evershipped==1
		drop temp evershipped
		
	* merging
	
		* land (origin)
		ren province_orig_id province_id
		sort province_id agprod_name
		merge province_id agprod_name using `temp_land'
		tab _merge
		keep if _merge==3
		drop _merge
		
		* island
		sort province_id
		merge province_id using `temp_island'
		tab _merge
		drop if _merge==2
		drop _merge
	
		* origin 
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_price'
		tab _merge
		drop if _merge==2
		drop _merge

		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_production'
		tab _merge
		drop if _merge==2
		drop _merge
		
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_imports'
		tab _merge
		drop if _merge==2
		drop _merge
		
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_exports'
		tab _merge
		drop if _merge==2
		drop _merge		
			
		ren province_id province_orig_id
		ren price price_orig
		ren price_predict price_predict_orig
		ren price_predict_se price_predict_se_orig
		ren price_island price_island_orig
		ren price_market price_market_orig
		ren price_predict_island price_predict_island_orig
		ren price_predict_market price_predict_market_orig
		ren volume production_orig
		ren imports imports_orig
		ren exports exports_orig
		ren theta theta_orig
		ren theta_se theta_se_orig
		ren island_id island_orig_id
		ren fsub fsub_orig
		
		* land (destination)
		ren province_dest_id province_id
		sort province_id agprod_name
		merge province_id agprod_name using `temp_land'
		tab _merge
		drop if _merge==2
		drop _merge
		
		* island
		sort province_id
		merge province_id using `temp_island'
		tab _merge
		drop if _merge==2
		drop _merge
		
		* destination 
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_price'
		tab _merge
		drop if _merge==2
		drop _merge

		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_production'
		tab _merge
		drop if _merge==2
		drop _merge

		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_imports'
		tab _merge
		drop if _merge==2
		drop _merge
		
		sort year province_id agprod_name
		merge year province_id agprod_name using `temp_exports'
		tab _merge
		drop if _merge==2
		drop _merge		
		
		ren province_id province_dest_id
		ren price price_dest
		ren price_predict price_predict_dest
		ren price_predict_se price_predict_se_dest
		ren price_island price_island_dest
		ren price_market price_market_dest
		ren price_predict_island price_predict_island_dest
		ren price_predict_market price_predict_market_dest
		ren volume production_dest
		ren imports imports_dest
		ren exports exports_dest
		ren fsub fsub_dest
		ren theta theta_dest
		ren theta_se theta_se_dest
		ren island_id island_dest_id
		replace production_orig = production_orig * 1000 /* unit conversion */
		replace production_dest = production_dest * 1000 /* unit conversion */	
				
	* Step 9: getting the distance data
		
			* Destination
				ren province_dest_id province_id
				sort province_id
				
				preserve
				clear
				use "$dir_province\province_id_MASTER.dta"
				sort province_id
				save "$dir_province\province_id_MASTER.dta", replace
				restore
				
				merge province_id using "$dir_province\province_id_MASTER.dta"
				tab _merge
				keep if _merge==3
				drop _merge
				ren province_id_trade province_dest_id_trade
				ren province_name province_dest_name
				ren province_id province_dest_id
				
			* Origin
				ren province_orig_id province_id
				sort province_id
								
				merge province_id using "$dir_province\province_id_MASTER.dta"
				tab _merge
				keep if _merge==3
				drop _merge
				ren province_id province_orig_id
				ren province_name province_orig_name
				ren province_id_trade province_orig_id_trade
				
			* Attaching shipping distances

				* need to give isabela city and cotabato city id's (isabela city given province_id of basilan (16); cotabato city given province id of maguindanao (51)
				replace province_orig_id_trade=51 if province_orig_id==83 /* Cotabato city */
				replace province_orig_id_trade=16 if province_orig_id==84 /* Isabela city */	
				replace province_dest_id_trade=51 if province_dest_id==83 /* Cotabato city */
				replace province_dest_id_trade=16 if province_dest_id==84 /* Isabela city */		
				
				sort province_orig_id_trade province_dest_id_trade
				merge province_orig_id_trade province_dest_id_trade using "$dir_distance\shippingdist_091310.dta"
				tab _merge /* perfect */
				drop if _merge==2
				drop _merge
** Saving the bilateral trade flows with zeros

lab dat "Agricultural Trade Flows with Zeros"
save agtrade_zeros.dta, replace



			