function [ML, tao] = tao_complete_071011(sigma,price_ratio,anytrade,yearFE,tao_max)
    % for complete information

    sigma_tao = sigma;
    T = max(size(price_ratio)); % this way it doesn't matter
    assert(min(size(price_ratio))==1)

    tao_min = -min(yearFE); % this way, can never estimate a tao less than 0
    tol = 0.00001;
    diff = 1;
    maxiter = 100;
    iter = 0;

    probnotrade = NaN(T,1);
    probtrade = NaN(T,1);
    shouldbezero = NaN(T,1);
    
    % ML of tao
    while diff>tol & iter<maxiter
        tao = (tao_max + tao_min) ./2; % halfway point
        iter = iter+1;
        for t = 1:T
            probnotrade(t) = (normpdf(log(price_ratio(t))-log(tao+yearFE(t)),0,sigma_tao))./(1-normcdf(log(price_ratio(t))-log(tao+yearFE(t)),0,sigma_tao));
            probtrade(t) =  (1/sigma_tao)*(log(tao+yearFE(t))-log(price_ratio(t)));
            shouldbezero(t) = (anytrade(t)==0).*probnotrade(t)-(anytrade(t)==1).*probtrade(t);
        end
        error_solve = sum(shouldbezero);
        % if error_solve is negative, that means the tao is too high
        tao_max = (error_solve>0).*tao_max + (error_solve<0).*tao;
        % if error_solve is positive, that means the tao is too low
        tao_min = (error_solve<0).*tao_min + (error_solve>0).*tao;
        diff = norm(tao_min-tao_max);
    end
    ML = 0;
    for t = 1:T
        ML=ML+sum(sum((anytrade(t)==0).*log(1-normcdf(log(price_ratio(t))-log(tao+yearFE(t)),0,sigma_tao))+...
            (anytrade(t)==1).*log(normpdf(log(price_ratio(t))-log(tao+yearFE(t)),0,sigma_tao))));
    end
end
